## optee-client 4.1.0

=== Makefile ===
# Public variables are stored in config.mk
include ./config.mk

#########################################################################
# Set Internal Variables						#
# May be modified to match your setup                                   #
#########################################################################
ifneq ($(V),1)
VPREFIX := @
endif
export VPREFIX

EXPORT_DIR ?= $(O)/export
DESTDIR ?= $(EXPORT_DIR)
SBINDIR ?= /usr/sbin
LIBDIR ?= /usr/lib
INCLUDEDIR ?= /usr/include
sbindir ?= $(SBINDIR)
libdir ?= $(LIBDIR)
includedir ?= $(INCLUDEDIR)

WITH_TEEACL ?= 1

.PHONY: all build build-libteec build-libckteec build-libseteec \
	build-libteeacl install copy_export clean cscope \
	clean-cscope \
	checkpatch-pre-req checkpatch-modified-patch checkpatch-modified-file \
	checkpatch-last-commit-patch checkpatch-last-commit-file \
	checkpatch-base-commit-patch checkpatch-base-commit-file \
	checkpatch-all-files distclean

all: build install

build-libteec:
	@echo "Building libteec.so"
	@$(MAKE) --directory=libteec --no-print-directory --no-builtin-variables \
			CFG_TEE_BENCHMARK=$(CFG_TEE_BENCHMARK) CFG_TEE_CLIENT_LOG_LEVEL=$(CFG_TEE_CLIENT_LOG_LEVEL)

build-tee-supplicant: build-libteec
	@echo "Building tee-supplicant"
	$(MAKE) --directory=tee-supplicant  --no-print-directory --no-builtin-variables CFG_TEE_SUPP_LOG_LEVEL=$(CFG_TEE_SUPP_LOG_LEVEL)

build: build-libteec build-tee-supplicant build-libckteec build-libseteec
ifeq ($(WITH_TEEACL),1)
build: build-libteeacl
endif

build-libckteec: build-libteec
	@echo "Building libckteec.so"
	@$(MAKE) --directory=libckteec --no-print-directory --no-builtin-variables

build-libseteec: build-libteec
	@echo "Building libseteec.so"
	@$(MAKE) --directory=libseteec --no-print-directory --no-builtin-variables

build-libteeacl:
	@echo "Building libteeacl.so"
	@$(MAKE) --directory=libteeacl --no-print-directory --no-builtin-variables

install: copy_export

clean: clean-libteec clean-tee-supplicant clean-cscope clean-libckteec \
	clean-libseteec
ifeq ($(WITH_TEEACL),1)
clean: clean-libteeacl
endif

clean-libteec:
	@$(MAKE) --directory=libteec --no-print-directory clean

clean-tee-supplicant:
	@$(MAKE) --directory=tee-supplicant --no-print-directory clean

clean-libckteec:
	@$(MAKE) --directory=libckteec --no-print-directory clean

clean-libseteec:
	@$(MAKE) --directory=libseteec --no-print-directory clean

clean-libteeacl:
	@$(MAKE) --directory=libteeacl --no-print-directory clean

cscope:
	@echo "  CSCOPE"
	${VPREFIX}find ${CURDIR} -name "*.[chsS]" > cscope.files
	${VPREFIX}cscope -b -q -k

clean-cscope:
	${VPREFIX}rm -f cscope.*

# Various checkpatch targets. The ones ending with "patch" only considers the
# patch, whilst the ones ending with "file" checks the complete file.
# +-------------------------------+------------+----------------------------+
# | Target commit                 | File/Patch | Comment                    |
# +-------------------------------+------------+----------------------------+
# | checkpatch-modified-patch     | Patch      | Check local modifications  |
# +-------------------------------+------------+----------------------------+
# | checkpatch-modified-file      | File       | Check Local modifications  |
# +-------------------------------+------------+----------------------------+
# | checkpatch-last-commit-patch  | Patch      | Check against HEAD^        |
# +-------------------------------+------------+----------------------------+
# | checkpatch-last-commit-file   | File       | Check against HEAD^        |
# +-------------------------------+------------+----------------------------+
# | checkpatch-base-commit-patch  | Patch      | Against specic commit      |
# +-------------------------------+------------+----------------------------+
# | checkpatch-base-commit-file   | File       | Against specic commit      |
# +-------------------------------+------------+----------------------------+
# | checkpatch-all-files          | File       | Check all tracked files    |
# +-------------------------------+------------+----------------------------+
CHECKPATCH_IGNORE	?= --ignore NEW_TYPEDEFS --no-signoff
CHECKPATCH_STRICT	?= --strict
CHECKPATCH_ARGS		?= $(CHECKPATCH_IGNORE) $(CHECKPATCH_STRICT) --no-tree --terse
CHECKPATCH_PATCH_ARGS   := $(CHECKPATCH_ARGS) --patch
CHECKPATCH_FILE_ARGS 	:= $(CHECKPATCH_ARGS) --file --no-patch

checkpatch-pre-req:
	@echo "  CHECKPATCH"
ifndef CHECKPATCH
	$(error "Environment variable CHECKPATCH must point to Linux kernels checkpatch script")
else
ifeq (,$(wildcard ${CHECKPATCH}))
	$(error "CHECKPATCH points to the incorrect file")
endif
endif

checkpatch-modified-patch: checkpatch-pre-req
	${VPREFIX}git diff | ${CHECKPATCH} $(CHECKPATCH_PATCH_ARGS) - || true

checkpatch-modified-file: checkpatch-pre-req
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git diff --name-only)


checkpatch-last-commit-patch: checkpatch-pre-req
	${VPREFIX}git diff HEAD^ | ${CHECKPATCH} $(CHECKPATCH_PATCH_ARGS) - || true

checkpatch-last-commit-file: checkpatch-pre-req
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git diff --name-only HEAD^)


checkpatch-base-commit-patch: checkpatch-pre-req
ifndef BASE_COMMIT
	$(error "Environment variable BASE_COMMIT must contain a valid commit")
endif
	${VPREFIX}git diff $(BASE_COMMIT) | ${CHECKPATCH} $(CHECKPATCH_PATCH_ARGS) - || true

checkpatch-base-commit-file: checkpatch-pre-req
ifndef BASE_COMMIT
	$(error "Environment variable BASE_COMMIT must contain a valid commit")
endif
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git diff --name-only ${BASE_COMMIT})

checkpatch-all-files: checkpatch-pre-req
	${VPREFIX}${CHECKPATCH} $(CHECKPATCH_FILE_ARGS) $(shell git ls-files)

distclean: clean

copy_export: build
	mkdir -p $(DESTDIR)$(sbindir) $(DESTDIR)$(libdir) $(DESTDIR)$(includedir)
	cp config.mk $(DESTDIR)/$(includedir)/optee_client_config.mk
	cp -d ${O}/libteec/libteec.so* $(DESTDIR)$(libdir)
	cp -d ${O}/libteec/libteec.a $(DESTDIR)$(libdir)
	cp ${O}/tee-supplicant/tee-supplicant $(DESTDIR)$(sbindir)
	cp libteec/include/*.h $(DESTDIR)$(includedir)
	cp libckteec/include/*.h $(DESTDIR)$(includedir)
	cp -d ${O}/libckteec/libckteec.so* $(DESTDIR)$(libdir)
	cp -d ${O}/libckteec/libckteec.a $(DESTDIR)$(libdir)
ifeq ($(WITH_TEEACL),1)
	cp libteeacl/include/*.h $(DESTDIR)$(includedir)
	cp -d ${O}/libteeacl/libteeacl.so* $(DESTDIR)$(libdir)
	cp -d ${O}/libteeacl/libteeacl.a $(DESTDIR)$(libdir)
endif
	cp libseteec/include/*.h $(DESTDIR)$(includedir)
	cp -d ${O}/libseteec/libseteec.so* $(DESTDIR)$(libdir)
	cp -d ${O}/libseteec/libseteec.a $(DESTDIR)$(libdir)

=== libteeacl/CMakeLists.txt ===
project(teeacl
	VERSION 0.1.0
	LANGUAGES C
)

include(GNUInstallDirs)

################################################################################
# Source files
################################################################################
set(SRC
	src/group.c
	src/tee_uuid.c
)

################################################################################
# Built library
################################################################################
add_library(teeacl ${SRC})

set_target_properties(teeacl PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${PROJECT_VERSION_MAJOR}
)

################################################################################
# Flags always set
################################################################################
target_compile_definitions(teeacl
	PRIVATE -D_GNU_SOURCE
	PRIVATE -DBINARY_PREFIX="LT"
)

################################################################################
# Public and private header and library dependencies
################################################################################
target_include_directories(teeacl PUBLIC
	$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
	$<INSTALL_INTERFACE:include>
)

target_link_libraries(teeacl
	PUBLIC PkgConfig::uuid
)

################################################################################
# Install targets
################################################################################
install(TARGETS teeacl
	DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/include/" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

=== libteec/CMakeLists.txt ===
project(libteec
	VERSION 1.0.0
	LANGUAGES C)

################################################################################
# Packages
################################################################################
find_package(Threads REQUIRED)
if(NOT THREADS_FOUND)
	message(FATAL_ERROR "Threads not found")
endif()

################################################################################
# Configuration flags always included
################################################################################
option(CFG_TEE_BENCHMARK "Build with benchmark support" OFF)

set(CFG_TEE_CLIENT_LOG_LEVEL "1" CACHE STRING "libteec log level")
set(CFG_TEE_CLIENT_LOG_FILE "/data/tee/teec.log" CACHE STRING "Location of libteec log")

################################################################################
# Source files
################################################################################
set(SRC
	src/tee_client_api.c
	src/teec_trace.c
)

if(CFG_TEE_BENCHMARK)
	set(SRC ${SRC} src/teec_benchmark.c)
endif()

################################################################################
# Built library
################################################################################
add_library(teec ${SRC})

set(libteectgt teec)
configure_file(libteec.pc.in libteec.pc @ONLY)

set_target_properties(teec PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${PROJECT_VERSION_MAJOR}
)

################################################################################
# Flags always set
################################################################################
target_compile_definitions(teec
	PRIVATE -D_GNU_SOURCE
	PRIVATE -DDEBUGLEVEL_${CFG_TEE_CLIENT_LOG_LEVEL}
	PRIVATE -DTEEC_LOG_FILE="${CFG_TEE_CLIENT_LOG_FILE}"
	PRIVATE -DBINARY_PREFIX="LT"
)

################################################################################
# Optional flags
################################################################################
if(CFG_TEE_BENCHMARK)
	target_compile_definitions(teec PRIVATE -DCFG_TEE_BENCHMARK)
endif()

################################################################################
# Public and private header and library dependencies
################################################################################
target_include_directories(teec
	PUBLIC include
	PRIVATE src
)

target_link_libraries(teec
	PUBLIC ${CMAKE_THREAD_LIBS_INIT} # this is pthreads
)

################################################################################
# Install targets
################################################################################
# FIXME: This should in someway harmonize with CFG_TEE_CLIENT_LOAD_PATH
# FIXME: Should we change this to /usr/local/lib?
install(TARGETS teec LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
                      ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}")

install(DIRECTORY include
	DESTINATION ${CMAKE_INSTALL_PREFIX}
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libteec.pc"
	DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

=== libteec/Makefile ===
include ../flags.mk
include ../config.mk

OUT_DIR := $(OO)/libteec

.PHONY: all libteec clean

all: libteec
################################################################################
# Teec configuration
################################################################################
MAJOR_VERSION	:= 1
MINOR_VERSION	:= 0
PATCH_VERSION	:= 0
LIB_NAME	:= libteec.so
LIB_MAJOR	:= $(LIB_NAME).$(MAJOR_VERSION)
LIB_MAJ_MIN	:= $(LIB_NAME).$(MAJOR_VERSION).$(MINOR_VERSION)
LIB_MAJ_MIN_P	:= $(LIB_NAME).$(MAJOR_VERSION).$(MINOR_VERSION).$(PATCH_VERSION)

TEEC_SRCS	:= tee_client_api.c \
		   teec_trace.c
ifeq ($(CFG_TEE_BENCHMARK),y)
TEEC_SRCS	+= teec_benchmark.c
endif

TEEC_SRC_DIR	:= src
TEEC_OBJ_DIR	:= $(OUT_DIR)
TEEC_OBJS 	:= $(patsubst %.c,$(TEEC_OBJ_DIR)/%.o, $(TEEC_SRCS))
TEEC_INCLUDES 	:= \
		   ${CURDIR}/include \
		   ${CURDIR}/src

TEEC_CFLAGS	:= $(addprefix -I, $(TEEC_INCLUDES)) $(CFLAGS) -D_GNU_SOURCE \
		   -DDEBUGLEVEL_$(CFG_TEE_CLIENT_LOG_LEVEL) \
		   -DBINARY_PREFIX=\"TEEC\"

ifeq ($(CFG_TEE_BENCHMARK),y)
TEEC_CFLAGS	+= -DCFG_TEE_BENCHMARK
endif

TEEC_LFLAGS    := $(LDFLAGS) -lpthread
TEEC_LIBRARY	:= $(OUT_DIR)/$(LIB_MAJ_MIN_P)

libteec: $(TEEC_LIBRARY) $(OUT_DIR)/libteec.a
	$(VPREFIX)ln -sf $(LIB_MAJ_MIN_P) $(OUT_DIR)/$(LIB_MAJOR)
	$(VPREFIX)ln -sf $(LIB_MAJ_MIN_P) $(OUT_DIR)/$(LIB_MAJ_MIN)
	$(VPREFIX)ln -sf $(LIB_MAJOR) $(OUT_DIR)/$(LIB_NAME)

$(TEEC_LIBRARY): $(TEEC_OBJS)
	@echo "  LINK    $@"
	$(VPREFIX)$(CC) -shared -Wl,-soname,$(LIB_MAJOR) -o $@ $+ $(TEEC_LFLAGS)
	@echo ""

$(OUT_DIR)/libteec.a: $(TEEC_OBJS)
	@echo "  AR      $@"
	$(VPREFIX)$(AR) rcs $@ $+

$(TEEC_OBJ_DIR)/%.o: ${TEEC_SRC_DIR}/%.c
	$(VPREFIX)mkdir -p $(TEEC_OBJ_DIR)
	@echo "  CC      $<"
	$(VPREFIX)$(CC) $(TEEC_CFLAGS) -c $< -o $@

################################################################################
# Cleaning up configuration
################################################################################
clean:
	$(RM) $(TEEC_OBJS) $(TEEC_LIBRARY) $(OUT_DIR)/$(LIB_MAJOR) \
		$(OUT_DIR)/$(LIB_MAJ_MIN) $(OUT_DIR)/$(LIB_NAME)
	$(RM) $(OUT_DIR)/libteec.a
	$(call rmdir,$(OUT_DIR))

=== tee-supplicant/CMakeLists.txt ===
project(tee-supplicant C)

################################################################################
# Configuration flags always included
################################################################################
option(RPMB_EMU "Enable tee-supplicant to emulate RPMB" ON)
option(CFG_TA_GPROF_SUPPORT "Enable tee-supplicant support for TAs instrumented with gprof" ON)
option(CFG_FTRACE_SUPPORT "Enable tee-supplicant support for TAs instrumented with ftrace" ON)
option(CFG_TEE_SUPP_PLUGINS "Enable tee-supplicant plugin support" ON)

set(CFG_TEE_SUPP_LOG_LEVEL "1" CACHE STRING "tee-supplicant log level")
# FIXME: Question is, is this really needed? Should just use defaults from # GNUInstallDirs?
set(CFG_TEE_CLIENT_LOAD_PATH "/lib" CACHE STRING "Colon-separated list of paths where to look for TAs (see also --ta-dir)")
set(CFG_TEE_FS_PARENT_PATH "/data/tee" CACHE STRING "Location of TEE filesystem (secure storage)")
# FIXME: Why do we have if defined(CFG_GP_SOCKETS) && CFG_GP_SOCKETS == 1 in the c-file?
set(CFG_GP_SOCKETS "1" CACHE STRING "Enable GlobalPlatform Socket API support")
set(CFG_TEE_PLUGIN_LOAD_PATH "/usr/lib/tee-supplicant/plugins/" CACHE STRING "tee-supplicant's plugins path")

if(CFG_TEE_SUPP_PLUGINS)
	set(CMAKE_INSTALL_RPATH "${CFG_TEE_PLUGIN_LOAD_PATH}")
endif()

################################################################################
# Source files
################################################################################
set(SRC
	src/handle.c
	src/hmac_sha2.c
	src/rpmb.c
	src/sha2.c
	src/tee_supp_fs.c
	src/tee_supplicant.c
	src/teec_ta_load.c
)

if(CFG_GP_SOCKETS)
	set(SRC ${SRC} src/tee_socket.c)
endif()

if(CFG_TA_GPROF_SUPPORT OR CFG_FTRACE_SUPPORT)
	set(SRC ${SRC} src/prof.c)
endif()

if(CFG_TEE_SUPP_PLUGINS)
	set(SRC ${SRC} src/plugin.c)
endif()

################################################################################
# Built binary
################################################################################
add_executable(${PROJECT_NAME} ${SRC})

################################################################################
# Flags always set
################################################################################
target_compile_definitions(${PROJECT_NAME}
	PRIVATE -DDEBUGLEVEL_${CFG_TEE_SUPP_LOG_LEVEL}
	PRIVATE -DTEEC_LOAD_PATH="${CFG_TEE_CLIENT_LOAD_PATH}"
	PRIVATE -DTEE_FS_PARENT_PATH="${CFG_TEE_FS_PARENT_PATH}"
	PRIVATE -DBINARY_PREFIX="TSUP"
)

################################################################################
# Optional flags
################################################################################
if(CFG_GP_SOCKETS)
	target_compile_definitions(${PROJECT_NAME}
		PRIVATE -DCFG_GP_SOCKETS=${CFG_GP_SOCKETS})
endif()

if(RPMB_EMU)
	target_compile_definitions(${PROJECT_NAME}
		PRIVATE -DRPMB_EMU=1)
endif()

if(CFG_TA_GPROF_SUPPORT)
	target_compile_definitions(${PROJECT_NAME}
		PRIVATE -DCFG_TA_GPROF_SUPPORT)
endif()

if(CFG_FTRACE_SUPPORT)
	target_compile_definitions(${PROJECT_NAME}
		PRIVATE -DCFG_FTRACE_SUPPORT)
endif()

if(CFG_TEE_SUPP_PLUGINS)
	target_compile_definitions(${PROJECT_NAME}
		PRIVATE -DTEE_SUPP_PLUGINS
		PRIVATE -DTEE_PLUGIN_LOAD_PATH="${CFG_TEE_PLUGIN_LOAD_PATH}"
	)
endif()

################################################################################
# Public and private header and library dependencies
################################################################################
target_include_directories(${PROJECT_NAME}
	PRIVATE src
	PRIVATE ../libteec/src
)

target_link_libraries(${PROJECT_NAME}
	PRIVATE teec
)

if(CFG_TEE_SUPP_PLUGINS)
	target_link_libraries(${PROJECT_NAME}
		PRIVATE dl
	)
endif()

################################################################################
# Install targets
################################################################################
install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR})

=== tee-supplicant/Makefile ===
include ../flags.mk
include ../config.mk

OUT_DIR := $(OO)/tee-supplicant

# Emulate RPMB ioctl's by default
RPMB_EMU	?= 1

.PHONY: all tee-supplicant clean

all: tee-supplicant
################################################################################
# Teec configuration
################################################################################
PACKAGE_NAME	:= tee-supplicant

TEES_SRCS	:= tee_supplicant.c \
		   teec_ta_load.c \
		   tee_supp_fs.c \
		   rpmb.c \
		   handle.c

ifeq ($(CFG_GP_SOCKETS),y)
TEES_SRCS 	+= tee_socket.c
endif

ifeq ($(RPMB_EMU),1)
TEES_SRCS	+= sha2.c hmac_sha2.c
endif
ifneq (,$(filter y,$(CFG_TA_GPROF_SUPPORT) $(CFG_FTRACE_SUPPORT)))
TEES_SRCS	+= prof.c
endif

ifeq ($(CFG_TEE_SUPP_PLUGINS),y)
TEES_SRCS 	+= plugin.c
endif

TEES_SRC_DIR	:= src
TEES_OBJ_DIR	:= $(OUT_DIR)
TEES_OBJS 	:= $(patsubst %.c,$(TEES_OBJ_DIR)/%.o, $(TEES_SRCS))
TEES_INCLUDES 	:= ${CURDIR}/../libteec/include \
		   ${CURDIR}/src \
		   ${CURDIR}/../libteec/src \

TEES_CFLAGS	:= $(addprefix -I, $(TEES_INCLUDES)) $(CFLAGS) \
		   -DDEBUGLEVEL_$(CFG_TEE_SUPP_LOG_LEVEL) \
		   -DBINARY_PREFIX=\"TEES\" \
		   -DTEE_FS_PARENT_PATH=\"$(CFG_TEE_FS_PARENT_PATH)\" \
		   -DTEEC_LOAD_PATH=\"$(CFG_TEE_CLIENT_LOAD_PATH)\" \

ifeq ($(CFG_GP_SOCKETS),y)
TEES_CFLAGS	+= -DCFG_GP_SOCKETS=1
endif
ifeq ($(RPMB_EMU),1)
TEES_CFLAGS	+= -DRPMB_EMU=1
endif
TEES_FILE	:= $(OUT_DIR)/$(PACKAGE_NAME)
TEES_LFLAGS    := $(LDFLAGS) -L$(OUT_DIR)/../libteec -lteec

ifeq ($(CFG_TA_GPROF_SUPPORT),y)
TEES_CFLAGS	+= -DCFG_TA_GPROF_SUPPORT
endif

ifeq ($(CFG_FTRACE_SUPPORT),y)
TEES_CFLAGS	+= -DCFG_FTRACE_SUPPORT
endif

ifeq ($(CFG_TEE_SUPP_PLUGINS),y)
TEES_CFLAGS	+= -DTEE_SUPP_PLUGINS \
		   -DTEE_PLUGIN_LOAD_PATH=\"$(CFG_TEE_PLUGIN_LOAD_PATH)\"
endif

TEES_LFLAGS	+= -lpthread
# Needed to get clock_gettime() for for glibc versions before 2.17
TEES_LFLAGS	+= -lrt

ifeq ($(CFG_TEE_SUPP_PLUGINS),y)
# Needed to dynamically load user plugins
TEES_LFLAGS	+= -ldl
# Needed for dlopen()
TEES_LFLAGS 	+= -Wl,-rpath=$(CFG_TEE_PLUGIN_LOAD_PATH)
endif

tee-supplicant: $(TEES_FILE)

$(TEES_FILE): $(TEES_OBJS)
	@echo "  LINK    $@"
	$(VPREFIX)$(CC) -o $@ $+ $(TEES_LFLAGS)
	@echo ""

$(TEES_OBJ_DIR)/%.o: $(TEES_SRC_DIR)/%.c
	$(VPREFIX)mkdir -p $(dir $@)
	@echo "  CC      $<"
	$(VPREFIX)$(CC) $(TEES_CFLAGS) $(TEES_CFLAGS_$(notdir $<)) -c $< -o $@

################################################################################
# Cleaning up configuration
################################################################################
clean:
	$(RM) $(TEES_OBJS) $(TEES_FILE)
	$(call rmdir,$(OUT_DIR))

=== debian/changelog ===
optee-client (4.1.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063174

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 23:09:47 +0000

optee-client (4.1.0-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 29 Jan 2024 06:25:33 +0800

optee-client (4.0.0-1) unstable; urgency=low

  * New upstream release.
    - FTCBFS fixed by the upstream (Closes: #1023233)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 11 Dec 2023 01:07:42 +0800

=== debian/control ===
Source: optee-client
Priority: optional
Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 12),
               docbook-xml,
               docbook-xsl,
               pkg-config,
               uuid-dev,
               xsltproc
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/OP-TEE/optee_client
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/optee-client
Vcs-Git: https://salsa.debian.org/debian/optee-client.git

Package: optee-client-dev
Section: libdevel
Architecture: arm64 armhf
Multi-Arch: same
Depends: libckteec0t64 (= ${binary:Version}),
         libseteec0t64 (= ${binary:Version}),
         libteeacl0.1.0t64 (= ${binary:Version}),
         libteec1t64 (= ${binary:Version}),
         ${misc:Depends}
Description: normal world user space client APIs for OP-TEE (development)
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains the development files OpTEE Client API

Package: libteeacl0.1.0t64
Provides: ${t64:Provides}
Replaces: libteeacl0.1.0
Breaks: libteeacl0.1.0 (<< ${source:Version})
Architecture: arm64 armhf
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains libteeacl library.

Package: libteec1t64
Provides: ${t64:Provides}
Replaces: libteec1
Breaks: libteec1 (<< ${source:Version})
Architecture: arm64 armhf
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains libteec library.

Package: libckteec0t64
Provides: ${t64:Provides}
Replaces: libckteec0
Breaks: libckteec0 (<< ${source:Version})
Architecture: arm64 armhf
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains libckteec library.

Package: libseteec0t64
Provides: ${t64:Provides}
Replaces: libseteec0
Breaks: libseteec0 (<< ${source:Version})
Architecture: arm64 armhf
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 libseteec stands for secure element control.
 .
 This package contains libseteec library.

Package: tee-supplicant
Architecture: arm64 armhf
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: normal world user space client APIs for OP-TEE
 OP-TEE is a Trusted Execution Environment (TEE) designed as companion to a
 non-secure Linux kernel running on Arm; Cortex-A cores using the TrustZone
 technology. OP-TEE implements TEE Internal Core API v1.1.x which is the API
 exposed to Trusted Applications and the TEE Client API v1.0, which is the
 API describing how to communicate with a TEE. This package provides the TEE
 Client API library.
 .
 This package contains tee-supplicant executable.

## optee-client 4.2.0

=== debian/changelog ===
optee-client (4.2.0-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 17 Apr 2024 01:13:18 +0800

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: optee-client
 Priority: optional
 Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
-Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 12),
                docbook-xml,
                docbook-xsl,
+               dpkg-dev (>= 1.22.5),
                pkg-config,
                uuid-dev,
                xsltproc

## optee-client 4.3.0

=== libteec/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project(libteec
-	VERSION 1.0.0
+	VERSION 2.0.0
 	LANGUAGES C)
 
 ################################################################################
@@ -13,8 +13,6 @@
 ################################################################################
 # Configuration flags always included
 ################################################################################
-option(CFG_TEE_BENCHMARK "Build with benchmark support" OFF)
-
 set(CFG_TEE_CLIENT_LOG_LEVEL "1" CACHE STRING "libteec log level")
 set(CFG_TEE_CLIENT_LOG_FILE "/data/tee/teec.log" CACHE STRING "Location of libteec log")
 
@@ -26,17 +24,13 @@
 	src/teec_trace.c
 )
 
-if(CFG_TEE_BENCHMARK)
-	set(SRC ${SRC} src/teec_benchmark.c)
-endif()
-
 ################################################################################
 # Built library
 ################################################################################
 add_library(teec ${SRC})
 
 set(libteectgt teec)
-configure_file(libteec.pc.in libteec.pc @ONLY)
+configure_file(teec.pc.in teec.pc @ONLY)
 
 set_target_properties(teec PROPERTIES
 	VERSION ${PROJECT_VERSION}
@@ -52,13 +46,6 @@
 	PRIVATE -DTEEC_LOG_FILE="${CFG_TEE_CLIENT_LOG_FILE}"
 	PRIVATE -DBINARY_PREFIX="LT"
 )
-
-################################################################################
-# Optional flags
-################################################################################
-if(CFG_TEE_BENCHMARK)
-	target_compile_definitions(teec PRIVATE -DCFG_TEE_BENCHMARK)
-endif()
 
 ################################################################################
 # Public and private header and library dependencies
@@ -84,6 +71,6 @@
 	DESTINATION ${CMAKE_INSTALL_PREFIX}
 )
 
-install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libteec.pc"
+install(FILES "${CMAKE_CURRENT_BINARY_DIR}/teec.pc"
 	DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
 )

=== tee-supplicant/CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,7 @@
 	src/hmac_sha2.c
 	src/rpmb.c
 	src/sha2.c
+	src/sd_notify.c
 	src/tee_supp_fs.c
 	src/tee_supplicant.c
 	src/teec_ta_load.c

=== debian/changelog ===
optee-client (4.3.0-1) unstable; urgency=low

  * New upstream version 4.3.0
  * debian/control: Build-Depends: change pkg-config to pkgconf
  * Upstream SONAME bump: libteec1t64 to libteec2

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Tue, 23 Jul 2024 04:03:44 +0800

## optee-client 4.4.0

=== debian/changelog ===
optee-client (4.4.0-1) unstable; urgency=low

  * New upstream version 4.4.0

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 16 Jan 2025 21:12:50 +0800

## optee-client 4.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(optee_client C)

# https://cmake.org/Wiki/CMake_Useful_Variables
set(CMAKE_TOOLCHAIN_FILE CMakeToolchain.txt)

option(CFG_WERROR "Build with -Werror" TRUE)
option(WITH_TEEACL "Build libteeacl" TRUE)

include(GNUInstallDirs)

################################################################################
# Compiler flags:
#   We want to use the same flags in the entire optee_client git
################################################################################
add_compile_options(
	-Wall -Wbad-function-cast -Wcast-align
	-Werror-implicit-function-declaration -Wextra
	-Wfloat-equal -Wformat-nonliteral -Wformat-security
	-Wformat=2 -Winit-self -Wmissing-declarations
	-Wmissing-format-attribute -Wmissing-include-dirs
	-Wmissing-noreturn -Wmissing-prototypes -Wnested-externs
	-Wpointer-arith -Wshadow -Wstrict-prototypes
	-Wswitch-default -Wwrite-strings -fPIC
)
if("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
    add_compile_options(
        -Wunsafe-loop-optimizations
    )
endif()
if(CFG_WERROR)
    add_compile_options(-Werror)
endif(CFG_WERROR)

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

add_subdirectory(libteec)
add_subdirectory(tee-supplicant)
add_subdirectory(libckteec)
if(WITH_TEEACL)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(uuid REQUIRED IMPORTED_TARGET uuid)
    add_subdirectory(libteeacl)
endif(WITH_TEEACL)
add_subdirectory(libseteec)

=== libteeacl/CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,8 @@
 # Built library
 ################################################################################
 add_library(teeacl ${SRC})
+
+configure_file(teeacl.pc.in teeacl.pc @ONLY)
 
 set_target_properties(teeacl PROPERTIES
 	VERSION ${PROJECT_VERSION}
@@ -51,3 +53,7 @@
 )
 
 install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/include/" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
+
+install(FILES "${CMAKE_CURRENT_BINARY_DIR}/teeacl.pc"
+	DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
+)

=== libckteec/include/CMakeLists.txt ===
project(libckteec-headers C)

FILE(GLOB INSTALL_HEADERS "*.h")

add_library(${PROJECT_NAME} INTERFACE)
target_include_directories(
        ${PROJECT_NAME}
        INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:{CMAKE_INSTALL_INCLUDEDIR}>
)

install(FILES ${INSTALL_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== debian/changelog ===
optee-client (4.5.0-1) unstable; urgency=low

  * New upstream version 4.5.0

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Tue, 21 Jan 2025 08:24:22 +0800

optee-client (4.4.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix empty directory loss (DEP17 P6, Closes: #1092280)
  * Fix FTCBFS: Export PKG_CONFIG for make install.

 -- Helmut Grohne <helmut@subdivi.de>  Mon, 06 Jan 2025 15:00:48 +0100
